
// ------------------------------------------------------------
// -------------------- the class -----------------------------
// ------------------------------------------------------------


// ---------------------------------------------------------------------
// ----------- Luna construction -------------------------------------

Grid [] dataViz;
float [] angulosLuna, orbitasLuna; // two aditional arrays to manage orbits

void hacerGrid() {

  // Creamos un array temporal
  Grid [] dataVizT = new Grid[elementosTotales];
  angulosLuna = new float[cols];
  orbitasLuna = new float[rows+1];

  // Management of current scale for rows and columns
  colAncho = (width-margenIzq-margenDer)/(cols); 
  rowAlto = (height-margenUp-margenDown)/(rows);

  // Management of rows and columns (this is a mess, I'm aware of it, nevermind #yolo)
  int rowT = 0;
  int colT = 0;
  int secuencia = 0;

  //Creamos la dataviz temporal
  for (int i = 0; i < elementosTotales; i++) {

    // Calculamos las posiciones (debemos recordar que esto cambi'o cuando decidimos hacer una luna)
    float angulo = map( i%5, 0, 5, 0, -90 );
    if (i < cols) angulosLuna[i] = angulo;
    float h = 120 + (rowT*(rowAlto/2));// hipotenusa
    float x = h * cos(radians(angulo));
    float y = h * sin(radians(angulo));

    orbitasLuna[rowT] = h;

    // The origin of the whole moon
    origenX = width/2 -110;
    origenY = height/2+120;

    //An adjusted origin for each Grid object
    x += origenX;
    y += origenY;


    // Asignamos el dato
    int dato = dataMatrix[rowT+1][colT];
    println("Estamos en row: "+rowT+" | col: "+colT+"   |dato: "+dato+"  -->sec: "+secuencia);

    // Hacemos el calculo del color
    float puntoColor = map( dato, numeroMenor, numeroMayor, 0, 1 );
    color cT = getColor(puntoColor);

    // Creamos el objeto
    dataVizT[ i ] = new Grid(x, y, dato, cT, secuencia);

    // Contadores
    if ( colT >= cols-1) {
      rowT++;
      colT = 0;
    } else {
      colT++;
    }
    secuencia++;
  }

  // IGualamos la DB
  dataViz = dataVizT;
}

// -------------------------------------------------------------------
// -------------------------------------------------------------------

class Grid {

  // Propiedades **********************************************************
  float x, y; 
  int dato; // El dato m'as importante, el n'umero
  color c; // El color 
  float escala, escalaActual, tamano, tamanoMax; // Con respecto al dato 
  int secuencia, cantidadPobladores;
  // Constructores ********************************************************
  Grid( float x, float y, int dato, color c, int secuencia) {
    this.x = x;
    this.y = y;
    this.c = c;
    this.dato = dato;
    this.escala = escala;
    this.escalaActual = 1; // Colocar en 0 para animarla
    this.tamano = map(dato, numeroMenor, numeroMayor, 40, rowAlto)*escalaMax;
    this.secuencia = secuencia;
    this.cantidadPobladores = round(dato/mapPobladores);
    crearPobladores(cantidadPobladores);
  }

  // Getters/Setters *****************************************************
  // - ( none so far) ---


  //Métodos **************************************************************
  void mostrar() {
    //Elipse de prueba
    if (centroPrueba) elipsePrueba();

    if (vizStyle == "circulos") mostrarCirculos();
  }
  // ------------------------------
  void elipsePrueba() {
    noStroke();
    fill(0);
    ellipse(x, y, 3, 3);
    fill(0, 0, 0, 30);
    if (colAncho > rowAlto) ellipse(x, y, rowAlto, rowAlto);
  }

  // -----------------------------

  void mostrarCirculos() {


    // Elipse de 'area
    fill(c);
    noStroke();
    //ellipse(x, y, tamano*escalaActual, tamano*escalaActual);

    // Pobladores
    if (pobladores) mostrarPobladores();

    // Elipse central de texto
    fill(255);
    fill(c);
    noStroke();
    ellipse(x, y, tamano/2.3, tamano/2.3);

    // Ectangle test
    // rectMode(CENTER);
    //fill(red(c), green(c), blue(c), 30);
    //rect(x, y, colAncho-1, rowAlto-1);

    // Mostramos la etiqueta
    fill(255, 255, 255, 240);
    textFont(numerosTotales, 11);
    textAlign(CENTER);
    text(dato, x, y+3);
  }
  //--------------------------
  // Variables de pobladores
  float [] angulo, sentido, sentidoAngulo, xPoblador, velAngulo;

  void crearPobladores(int cantidad) {
    //Creamos arreglos
    angulo = new float[cantidad];
    velAngulo  = new float[cantidad];
    sentidoAngulo  = new float[cantidad];
    sentido  = new float[cantidad];
    xPoblador = new float[cantidad];

    //Los llenamos
    for (int i = 0; i < cantidad; i++) {
      angulo[i] = random(360);
      sentido[i] = 1;
      if (random(2) > 1) sentido[i] = -1;

      sentidoAngulo[i] = 1;
      if (random(2) > 1) sentidoAngulo[i] = -1;
      xPoblador[i] = random(tamano);
      velAngulo[i] = random( velAnguloMin, velAnguloMax);
    }
  }
  void mostrarPobladores() {

    for (int i = 0; i < cantidadPobladores; i++) {
      // Variamos el angulo
      angulo[i] +=  velAngulo[i]*sentidoAngulo[i];

      //Variamos la X
      xPoblador[i] += velAngulo[i]*sentido[i];

      //Verificamos la X
      if (xPoblador[i] > tamano) sentido[i] = -1;
      if (xPoblador[i] < 0) sentido[i] = 1;

      // Propiedades de dibujo del poblador
      stroke(c);
      strokeWeight(random(2));
      fill(c);
      if (random(10) > 9.8) stroke(0);

      //Mostramos el poblador
      pushMatrix();
      translate(x, y);
      rotate(radians(angulo[i]));

      //if(random(10) > 4) line( 0, 0, xPoblador[i], 0);
      ellipse(xPoblador[i]*toleranciaPoblador, 0, 1, 1);

      //"MoonShadow, Moonshadow, moonshadow" -Cat Stevens
      fill(255);
      noStroke();
      ellipse(xPoblador[i]*toleranciaPoblador +4, 0+4, 1, 1);

      popMatrix();
    }
  }

  // Class ends with next } >>>>>
}

